#include "libfiles.h"

#include <sys/sendfile.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <iostream>

using namespace std;

int CopyFile(string source, string destination)
{
	//Here we use kernel-space copying for performance reasons
	int input, output;
	if( (input = open(source.c_str(), O_RDONLY)) == -1)
		return 0;
	mode_t mode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH | S_IXUSR;
	if( (output = open(destination.c_str(), O_WRONLY | O_CREAT | O_TRUNC, mode)) == -1)
	{
		cerr << "copying file failed, errno = " << errno << "\n";
		throw (string)("File copy failed");
		close(input);
		return 0;
	}
	struct stat buf;
	stat(source.c_str(), &buf);
	int result = sendfile(output, input, 0, buf.st_size) == -1;
	close(input);
	close(output);
	// TODO: fix permissions here
	
	return result;
}
